Index: /trunk/src/org/expeditee/io/KMSReader.java
===================================================================
--- /trunk/src/org/expeditee/io/KMSReader.java	(revision 120)
+++ /trunk/src/org/expeditee/io/KMSReader.java	(revision 121)
@@ -12,5 +12,5 @@
 
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameGraphics;
+import org.expeditee.gui.MessageBay;
 import org.expeditee.items.Constraint;
 import org.expeditee.items.Dot;
@@ -361,5 +361,5 @@
 		if (_FrameTags.get(tag) == null) {
 			if (!tag.equals("t") && !tag.equals("v"))
-				FrameGraphics.ErrorMessage("Tag '" + tag + "' in '" + line
+				MessageBay.errorMessage("Tag '" + tag + "' in '" + line
 						+ "' is not supported.");
 			return;
@@ -379,6 +379,6 @@
 	private Frame readFrameClass() throws IOException {
 		if (_data.size() == 0) {
-			FrameGraphics
-					.ErrorMessage("IO Error: File contains no valid KMS lines.");
+			MessageBay
+					.errorMessage("IO Error: File contains no valid KMS lines.");
 			return null;
 		}
Index: /trunk/src/org/expeditee/io/PNGWriter.java
===================================================================
--- /trunk/src/org/expeditee/io/PNGWriter.java	(revision 120)
+++ /trunk/src/org/expeditee/io/PNGWriter.java	(revision 121)
@@ -6,6 +6,6 @@
 import org.expeditee.agents.DefaultAgent;
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameGraphics;
 import org.expeditee.gui.FrameIO;
+import org.expeditee.gui.MessageBay;
 import org.expeditee.items.Item;
 
@@ -26,5 +26,5 @@
 			_writer.write(ItemWriter.NEW_LINE);
 		} else {
-			FrameGraphics.ErrorMessage("Could not create image for "
+			MessageBay.errorMessage("Could not create image for "
 					+ starting.getName());
 		}
Index: /trunk/src/org/expeditee/items/Circle.java
===================================================================
--- /trunk/src/org/expeditee/items/Circle.java	(revision 120)
+++ /trunk/src/org/expeditee/items/Circle.java	(revision 121)
@@ -7,4 +7,5 @@
 import java.awt.Graphics2D;
 import java.awt.Polygon;
+import java.awt.Rectangle;
 import java.awt.geom.Point2D;
 import java.util.Collection;
@@ -36,7 +37,7 @@
 		updatePolygon();
 	}
-	
+
 	public Collection<Item> getItemsToSave() {
-		Collection<Item> toSave =super.getItemsToSave();
+		Collection<Item> toSave = super.getItemsToSave();
 		toSave.add(_center);
 		return toSave;
@@ -196,5 +197,5 @@
 		return super.setHighlightColor(c);
 	}
-	
+
 	@Override
 	public void setFillColor(Color c) {
@@ -254,9 +255,9 @@
 	@Override
 	public float getSize() {
-		return (float)getRadius();
+		return (float) getRadius();
 	}
 
 	/**
-	 *Resizes the circle from the center.
+	 * Resizes the circle from the center.
 	 */
 	@Override
@@ -283,17 +284,32 @@
 	public void translate(Point2D origin, double ratio) {
 		updatePolygon();
-		//_center.translate(origin, ratio);
-		//super.translate(origin, ratio);
+		// _center.translate(origin, ratio);
+		// super.translate(origin, ratio);
+	}
+
+	@Override
+	public Rectangle[] getDrawingArea() {
+
+		float thickness = getThickness();
+		double radius = getRadius();
+
+		int size = (int) ((2 * radius) + 3.0 + thickness);
+
+		return new Rectangle[] { new Rectangle((int) (_center.getX() - radius
+				- 0.5 - (thickness / 2.0)), (int) (_center.getY() - radius
+				- 0.5 - (thickness / 2.0)), size, size) };
+	}
+
+	// @Override
+	// public void setPosition(float x, float y){
+	// float deltaX = x - _source._x;
+	// float deltaY = y = _source._y;
+	// _center.setPosition(deltaX, deltaY);
+	// super.setPosition(x,y);
+	// }
+	public Item getCenter() {
+		return _center;
 	}
 	
-//	@Override
-//	public void setPosition(float x, float y){
-//		float deltaX = x - _source._x;
-//		float deltaY = y = _source._y;
-//		_center.setPosition(deltaX, deltaY);
-//		super.setPosition(x,y);
-//	}
-	public Item getCenter(){
-		return _center;
-	}
+	
 }
Index: /trunk/src/org/expeditee/items/Dot.java
===================================================================
--- /trunk/src/org/expeditee/items/Dot.java	(revision 120)
+++ /trunk/src/org/expeditee/items/Dot.java	(revision 121)
@@ -86,5 +86,5 @@
 	@Override
 	public void paint(Graphics2D g) {
-		if (isHighlighted() /* && !Frame.FreeItems.contains(this) */) {
+		if (isHighlighted() /* && !FreeItems.getInstance().contains(this) */) {
 			Color highlightColor = getHighlightColor();
 			g.setColor(highlightColor);
Index: /trunk/src/org/expeditee/items/InteractiveWidget.java
===================================================================
--- /trunk/src/org/expeditee/items/InteractiveWidget.java	(revision 120)
+++ /trunk/src/org/expeditee/items/InteractiveWidget.java	(revision 121)
@@ -20,4 +20,5 @@
 import org.expeditee.gui.Frame;
 import org.expeditee.gui.FrameGraphics;
+import org.expeditee.gui.FreeItems;
 
 /**
@@ -53,11 +54,13 @@
 	// world
 	private Text _textRepresentation;
+	
+	private final static Color FREESPACE_BACKCOLOR = new Color(100,100,100,128);
 
 	// A flag for signifying whether the swing components are ready to paint.
 	// If the swing components has not been layed out, if they are painted they
-	// will
-	// not draw in the correct positions.
+	// will not draw in the correct positions.
+	// Also for setting AWT and Swing -Related drawing options after construction
 	private boolean _isReadyToPaint = false;
-
+	
 	/**
 	 * Creates a InteractiveWidget from a text item.
@@ -356,5 +359,5 @@
 		_swingComponent = component;
 		_textRepresentation = source;
-
+		
 		_minWidth = minWidth;
 
@@ -742,4 +745,6 @@
 
 		}
+		
+		FrameGraphics.invalidateItem(_d1, _swingComponent.getBounds());
 	}
 
@@ -772,5 +777,5 @@
 
 				synchronized (_widgetsToAddLater) {
-					_widgetsToAddLater.add(new WidgetInfo(this, e));
+					_widgetsToAddLater.add(new DelayedWidgetEvent(this, e));
 				}
 				SwingUtilities.invokeLater(new AddToFrameLater());
@@ -780,4 +785,17 @@
 
 	}
+	
+	/**
+	 * @return True if at least one corner is floating
+	 */
+	public boolean isFloating() {
+		return _d1.isFloating() || _d2.isFloating()
+				|| _d3.isFloating() || _d4.isFloating();
+	}
+	
+	public boolean areCornersFullyAnchored() {
+		return _d1.getParent() != null && _d2.getParent() != null
+		&& _d3.getParent() != null && _d4.getParent() != null;
+	}
 
 	/**
@@ -786,7 +804,7 @@
 	 * @author Brook Novak
 	 */
-	class WidgetInfo {
-
-		WidgetInfo(InteractiveWidget widget, ItemParentStateChangedEvent e) {
+	class DelayedWidgetEvent {
+
+		DelayedWidgetEvent(InteractiveWidget widget, ItemParentStateChangedEvent e) {
 			_widget = widget;
 			_e = e;
@@ -802,5 +820,5 @@
 	 * before the browser singleton is made available.
 	 */
-	private static List<WidgetInfo> _widgetsToAddLater = new LinkedList<WidgetInfo>();
+	private static List<DelayedWidgetEvent> _widgetsToAddLater = new LinkedList<DelayedWidgetEvent>();
 
 	/**
@@ -810,10 +828,10 @@
 		public void run() {
 			if (!_widgetsToAddLater.isEmpty()) {
-				List<WidgetInfo> tmp = null;
+				List<DelayedWidgetEvent> tmp = null;
 				synchronized (_widgetsToAddLater) {
-					tmp = new LinkedList<WidgetInfo>(_widgetsToAddLater);
+					tmp = new LinkedList<DelayedWidgetEvent>(_widgetsToAddLater);
 				}
 				_widgetsToAddLater.clear();
-				for (WidgetInfo iwi : tmp) {
+				for (DelayedWidgetEvent iwi : tmp) {
 					iwi._widget.addJComponantToFrame(iwi._e);
 				}
@@ -821,4 +839,11 @@
 		}
 	}
+	
+	public void onBoundsChanged() {
+
+		_swingComponent.setBounds(getX(), getY(), getWidth(), getHeight());
+
+	}
+
 
 	/**
@@ -841,12 +866,36 @@
 		}
 
+	}
+
+	private void ignoreAWTPainting(Component c) {
+		
+		if (c instanceof JComponent) {
+			((JComponent)c).setDoubleBuffered(false);
+		}
+		
+		c.setIgnoreRepaint(true);
+		
+		if (c instanceof Container) {
+			for (Component child : ((Container) c).getComponents()) {
+
+				if (child instanceof Container) {
+					ignoreAWTPainting(child);
+				} else {
+					if (child instanceof JComponent) {
+						((JComponent)child).setDoubleBuffered(false);
+					}
+					
+					child.setIgnoreRepaint(true);
+				}
+			}
+		}
+	}
+	
+	private void prepareToPaint() {
 		_isReadyToPaint = true;
-	}
-
-	public void onBoundsChanged() {
-
-		_swingComponent.setBounds(getX(), getY(), getWidth(), getHeight());
-
-	}
+		layout(_swingComponent);
+		ignoreAWTPainting(_swingComponent);
+	}
+	
 
 	/**
@@ -858,8 +907,9 @@
 
 		if (!_isReadyToPaint) {
-			layout(_swingComponent);
+			prepareToPaint();
 		}
 
 		Point loc = _swingComponent.getLocation();
+		
 		g.translate(loc.x, loc.y - 1);
 		_swingComponent.paint(g);
@@ -867,26 +917,32 @@
 
 	}
-
-	/**
-	 * Called from the widgets corners: Whenever the corners are repainted and
-	 * the widget is floating (e.g. currently picked up / rubberbanding) then a
+	
+	/**
+	 * Invoked whenever the widget is to be repainted in free space.
+	 * @param g
+	 */
+	protected void paintInFreeSpace(Graphics g) {
+		g.setColor(FREESPACE_BACKCOLOR);
+		g.fillRect(getX(), getY(), getWidth(), getHeight());
+	}
+
+	/**
+	 * Called from the widgets corners: Whenever one of the corners are invoked for
+	 * a refill of the enclosed area.
+	 * 
+	 * If the widget is floating (e.g. currently picked up / rubberbanding) then a
 	 * shaded area is drawn instead of the actual widget so the manipulation of
-	 * the widget is as smooth as possible. The shaded area is only draw once so
-	 * it selects one of the 4 possible notifiers to be the actual trigger to
-	 * draw the shaded area
+	 * the widget is as smooth as possible. 
 	 * 
 	 * @param g
 	 * @param notifier
 	 */
-	void paint(Graphics g, WidgetCorner notifier) {
+	void paintFill(Graphics g) {
 		if (_swingComponent.getParent() == null) {
 			// Note that frames with @f may want to paint the widgets so do not
 			// paint over the widget interface in these cases: must only
 			// paint if an object is floating
-			if (notifier == _d4
-					&& (_d1.isFloating() || _d2.isFloating()
-							|| _d3.isFloating() || _d4.isFloating())) {
-				g.setColor(Color.DARK_GRAY);
-				g.fillRect(getX(), getY(), getWidth(), getHeight());
+			if (isFloating()) {
+				paintInFreeSpace(g);
 			}
 		}
@@ -909,5 +965,5 @@
 	 * 
 	 * The purpose of this is so that widgets can have an extra context: no
-	 * expeditee highlighting if focus is on a swing componet.
+	 * expeditee highlighting if focus is on a swing componant.
 	 * 
 	 * @param enable
@@ -921,7 +977,37 @@
 	}
 
-	public static boolean isExepiteeHighlightingEnabled() {
+	public static boolean isExpediteeHighlightingEnabled() {
 		return _isExepiteeHighlightingEnabled;
 	}
 
+	/**
+	 * Removes this widget from the parent frame or free space
+	 */
+	protected void removeSelf() {
+		
+		Frame parent = getParentFrame();
+		
+		if (parent == null) {
+			FreeItems.getInstance().removeAll(_expediteeItems);
+		} else {
+			parent.removeAllItems(_expediteeItems);
+		}
+
+	}
+	
+	/**
+	 * @return The parent frame. Null if has none. Note: Based on corners parents.
+	 */
+	public Frame getParentFrame() {
+
+		Frame parent = null;
+		if (_d1.getParent() != null) parent = _d1.getParent();
+		else if (_d2.getParent() != null) parent = _d2.getParent();
+		else if (_d3.getParent() != null) parent = _d3.getParent();
+		else if (_d4.getParent() != null) parent = _d4.getParent();
+		
+		return parent;
+	}
+	
+	
 }
Index: /trunk/src/org/expeditee/items/Item.java
===================================================================
--- /trunk/src/org/expeditee/items/Item.java	(revision 120)
+++ /trunk/src/org/expeditee/items/Item.java	(revision 121)
@@ -5,8 +5,10 @@
 import java.awt.Cursor;
 import java.awt.Dimension;
+import java.awt.GradientPaint;
 import java.awt.Graphics2D;
 import java.awt.Point;
 import java.awt.Polygon;
 import java.awt.Rectangle;
+import java.awt.Shape;
 import java.awt.Stroke;
 import java.awt.geom.AffineTransform;
@@ -29,4 +31,5 @@
 import org.expeditee.gui.FrameIO;
 import org.expeditee.gui.FrameUtils;
+import org.expeditee.gui.MessageBay;
 import org.expeditee.gui.Overlay;
 import org.expeditee.gui.Vector;
@@ -185,5 +188,8 @@
 		if (parent != null) {
 			dest.setID(source.getParentOrCurrentFrame().getNextItemID());
-		}
+		} 
+//		else {
+//			dest.setID(source.getID());
+//		}
 	}
 
@@ -254,5 +260,5 @@
 	private Color _color = null;
 
-	private Color _highlightColor = DEFAULT_HIGHLIGHT;
+	protected Color _highlightColor = DEFAULT_HIGHLIGHT;
 
 	private Color _colorBackground = null;
@@ -525,5 +531,5 @@
 	}
 
-	protected Polygon getCircle() {
+	protected Polygon getLinkPoly() {
 		if (_circle == null) {
 			int points = 16;
@@ -552,5 +558,5 @@
 			_circleCross = new Polygon();
 
-			Rectangle bounds = getCircle().getBounds();
+			Rectangle bounds = getLinkPoly().getBounds();
 			int x1 = (int) bounds.getMinX();
 			int x2 = (int) bounds.getMaxX();
@@ -943,11 +949,11 @@
 			g.setColor(fillColor);
 			// The painting is not efficient enough for gradients...
-			// Shape s = getEnclosedShape();
-			// Rectangle b = s.getBounds();
-			// GradientPaint gp = new GradientPaint((int) (b.x + b.width * 0.3),
-			// b.y, getFillColor(), (int) (b.x + b.width * 1.3), b.y,
-			// Color.white);
-			// g.setPaint(gp);
-			// g.fill(s);
+//			 Polygon s = getEnclosedShape();
+//			 Rectangle b = s.getBounds();
+//			 GradientPaint gp = new GradientPaint((int) (b.x + b.width * 0.3),
+//			 b.y, getFillColor(), (int) (b.x + b.width * 1.3), b.y,
+//			 Color.white);
+//			 g.setPaint(gp);
+//			 g.fillPolygon(s);
 			g.fillPolygon(getEnclosedShape());
 		}
@@ -994,4 +1000,7 @@
 	 */
 	public void removeAllLines() {
+		for (Line l : _lines) {
+			l.invalidateAll();
+		}
 		_lines.clear();
 	}
@@ -1016,5 +1025,6 @@
 	 */
 	public void removeLine(Line line) {
-		_lines.remove(line);
+		if (_lines.remove(line)) 
+			line.invalidateAll();
 	}
 
@@ -1024,10 +1034,10 @@
 			Simple.RunFrameAndReportError(this, new Context());
 			Simple.ProgramFinished();
-			FrameGraphics.DisplayMessage(AgentStats.getStats(), GREEN);
+			MessageBay.displayMessage(AgentStats.getStats(), GREEN);
 		} catch (ConcurrentModificationException ce) {
 			Simple.ProgramFinished();
 			ce.printStackTrace();
 		} catch (Exception e) {
-			FrameGraphics.LinkedErrorMessage(e.getMessage());
+			MessageBay.linkedErrorMessage(e.getMessage());
 			Simple.ProgramFinished();
 		}
@@ -1142,5 +1152,8 @@
 
 	public void setBackgroundColor(Color c) {
-		_colorBackground = c;
+		if (c != _colorBackground) {
+			_colorBackground = c;
+			invalidateCommonTrait(ItemAppearence.BackgroundColorChanged);
+		}
 	}
 
@@ -1163,5 +1176,8 @@
 	 */
 	public void setColor(Color c) {
-		_color = c;
+		if (c != _color) {
+			_color = c;
+			invalidateCommonTrait(ItemAppearence.ForegroundColorChanged);
+		}
 	}
 
@@ -1191,4 +1207,5 @@
 
 	public void setFillColor(Color c) {
+
 		_colorFill = c;
 
@@ -1198,8 +1215,13 @@
 				other.setFillColor(c);
 		}
+		
+		invalidateCommonTrait(ItemAppearence.FillColor);
+		invalidateFill();
 	}
 
 	public void setFillPattern(String patternLink) {
 		_fillPattern = patternLink;
+		invalidateCommonTrait(ItemAppearence.FillPattern);
+		invalidateFill();
 	}
 
@@ -1244,4 +1266,6 @@
 		for (Line line : lines)
 			line.setLinePattern(getLinePattern());
+		
+		
 	}
 
@@ -1254,10 +1278,12 @@
 	 */
 	public void setLink(String frameName) {
-		if (FrameIO.isValidLink(frameName))
+		if (FrameIO.isValidLink(frameName)) 
 			_link = frameName;
 		else
-			FrameGraphics.ErrorMessage("[" + frameName
+			MessageBay.errorMessage("[" + frameName
 					+ "] is not a valid frame name");
 		// TODO make this throw exceptions etc...
+		
+		invalidate(getLinkDrawArea());
 	}
 
@@ -1266,5 +1292,5 @@
 			_link_frameset = frameset;
 		else
-			FrameGraphics.ErrorMessage("[" + frameset
+			MessageBay.errorMessage("[" + frameset
 					+ "] is not a valid frameset name");
 		// TODO make this throw exceptions etc...
@@ -1280,5 +1306,5 @@
 			_link_template = template;
 		else
-			FrameGraphics.ErrorMessage("[" + template
+			MessageBay.errorMessage("[" + template
 					+ "] is not a valid frame name");
 		// TODO make this throw exceptions etc...
@@ -1316,4 +1342,22 @@
 
 	/**
+	 * Invalidates this, connected lines and fill
+	 * @param trait
+	 */
+	private void invalidateCommonTraitForAll(ItemAppearence trait) {
+		invalidateCommonTrait(trait);
+		for (Line line : getLines()) 
+			line.invalidateCommonTrait(trait);
+		if (_colorFill != null) {
+			invalidateFill(); // only invalidates if has fill
+		}
+		for(XRayable x: getEnclosures()){
+			x.invalidateCommonTrait(trait);
+		}
+
+	}
+	
+	
+	/**
 	 * Sets the position of this item on the screen
 	 * 
@@ -1326,4 +1370,8 @@
 		float deltaX = x - _x;
 		float deltaY = y - _y;
+		
+		if (deltaX == 0 && deltaY == 0) return;
+		
+		invalidateCommonTraitForAll(ItemAppearence.PreMoved);
 
 		_x = x;
@@ -1413,6 +1461,10 @@
 		}
 
-		for (Line line : getLines())
-			line.updatePolygon();
+		for (Line line : getLines()) {
+			line.updatePolygon();	
+		}
+		
+		invalidateCommonTraitForAll(ItemAppearence.PostMoved);
+		
 	}
 
@@ -1463,8 +1515,16 @@
 	 */
 	public void setThickness(float thick, boolean setConnectedThickness) {
+		
+		if (thick == _thickness) return;
+		boolean bigger = thick > _thickness;
+		
+		if (!bigger) invalidateCommonTrait(ItemAppearence.Thickness);
+		
 		_thickness = thick;
 		// update the size of any lines
 		for (Line line : getLines())
 			line.setThickness(thick, setConnectedThickness);
+
+		if (bigger) invalidateCommonTrait(ItemAppearence.Thickness);
 	}
 
@@ -1534,11 +1594,15 @@
 
 	public int setHighlightColor(Color c) {
+		
 		_highlightThickness = DEFAULT_HIGHLIGHT_THICKNESS;
-		if (c != null)
-			_highlightColor = c;
-		else
-			_highlightColor = DEFAULT_HIGHLIGHT;
+		
+		Color selColor = (c != null) ? c : DEFAULT_HIGHLIGHT;
+		if (_highlightColor != c) {
+			_highlightColor = selColor;
+			this.invalidateCommonTrait(ItemAppearence.HighlightColorChanged);
+		}
 
 		return Item.UNCHANGED_CURSOR;
+		
 	}
 
@@ -1589,5 +1653,8 @@
 	public void setHighlightMode(HighlightMode mode, Color color) {
 		setHighlightColor(color);
-		_mode = mode;
+		if (_mode != mode) {
+			_mode = mode;
+			this.invalidateCommonTrait(ItemAppearence.HighlightModeChanged);
+		}
 	}
 
@@ -1655,5 +1722,16 @@
 	 */
 	public void setEnclosedList(Collection<Item> enclosed) {
+		
+		boolean changed = (_enclosure == null && enclosed != null);
+		
+		if (_enclosure != null && enclosed == null) {
+			invalidateFill();
+		}
+		
 		_enclosure = enclosed;
+		
+		if (changed) {
+			invalidateFill();;
+		}
 	}
 
@@ -1773,4 +1851,5 @@
 		if (_actions == null || _actions.size() == 0) {
 			_poly = null;
+			invalidateCommonTrait(ItemAppearence.LinkChanged);
 		}
 		_actions = new LinkedList<String>();
@@ -1780,4 +1859,8 @@
 	protected int getLinkYOffset() {
 		return 0;
+	}
+	
+	protected Rectangle getLinkDrawArea() { // TODO: Revise
+		return new Rectangle(getX() - LEFT_MARGIN - 3, getY() + getLinkYOffset() - 3, 6, 6);
 	}
 
@@ -1804,5 +1887,5 @@
 
 			if (getLinkMark() && getLink() != null) {
-				g.drawPolygon(getCircle());
+				g.drawPolygon(getLinkPoly());
 
 				// if the link is not valid, cross out the circle
@@ -1812,6 +1895,6 @@
 
 			if (getActionMark() && getAction() != null) {
-				g.drawPolygon(getCircle());
-				g.fillPolygon(getCircle());
+				g.drawPolygon(getLinkPoly());
+				g.fillPolygon(getLinkPoly());
 
 				// if the link is not valid, cross out the circle
@@ -1973,4 +2056,7 @@
 	 */
 	public void translate(Point2D origin, double ratio) {
+		
+		invalidateCommonTraitForAll(ItemAppearence.PreMoved);
+		
 		_x = (float) (origin.getX() + ratio * (_x - origin.getX()));
 		_y = (float) (origin.getY() + ratio * (_y - origin.getY()));
@@ -1978,4 +2064,7 @@
 		for (Line line : getLines())
 			line.updatePolygon();
+		
+		invalidateCommonTraitForAll(ItemAppearence.PostMoved);
+		
 	}
 
@@ -2005,7 +2094,11 @@
 					setLinePattern(new int[] { LinePatterns[i], LinePatterns[i] });
 				}
+				
+				invalidateCommonTrait(ItemAppearence.ToggleDashed);
 				return;
 			}
 		}
+		
+		
 	}
 
@@ -2037,4 +2130,100 @@
 	public boolean isDeleted() {
 		return _deleted;
+	}
+	
+	/**
+	 * @return The full canvas that this item draws to. Must include highlighting bounds
+	 */
+	public Rectangle[] getDrawingArea() {
+		
+		return new Rectangle[] {
+				ItemUtils.expandRectangle(getPolygon().getBounds(), 
+				_highlightThickness)
+			};
+		
+	}
+	
+	/**
+	 * 
+	 * @param area
+	 * @return True if area intersects with this items drawing area.
+	 */
+	public final boolean isInDrawingArea(Area area) {
+		for (Rectangle r : getDrawingArea()) {
+			if (area.intersects(r)) return true;
+		}
+		return false;
+	}
+	
+	/**
+	 * Completetly invalidates the item - so that it should be redrawed.
+	 * Note: This is handled internally, it should be reare to invoke this
+	 * externally
+	 */
+	public final void invalidateAll() {
+		invalidate(getDrawingArea());
+	}
+	
+	/**
+	 * Invalidates areas on the parent frame.
+	 * Purpose: to be called on specific areas of the item that needs redrawing. 
+	 * @param damagedAreas
+	 */
+	protected final void invalidate(Rectangle[] damagedAreas) {
+		for (Rectangle r : damagedAreas) invalidate(r);
+	}
+	
+	/**
+	 * Invalidates areas on the parent frame.
+	 * Purpose: to be called on specific areas of the item that needs redrawing. 
+	 * @param damagedAreas
+	 */
+	protected final void invalidate(Rectangle damagedArea) {
+		FrameGraphics.invalidateItem(this, damagedArea);
+	}
+	
+	/**
+	 * Used to invalidate visual traits commonly shared by all items.
+	 * @param trait
+	 */
+	public final void invalidateCommonTrait(ItemAppearence trait) {
+		invalidate(getDamagedArea(trait));
+		
+		if (_colorFill != null && (
+				trait == ItemAppearence.Added
+				|| trait == ItemAppearence.Removed)
+				) {
+			invalidateFill();
+		}
+	}
+	
+	/**
+	 * Invalidates fill if has one, even if no color is set.
+	 */
+	public void invalidateFill() {
+		if (isLineEnd() && _enclosure != null) {
+			invalidate(getEnclosedShape().getBounds());
+		}
+	}
+	
+	/**
+	 * Default implementation always uses drawing area except for links,
+	 * where the link drawing area is used. Override to make item 
+	 * drawing more efficient - defining only parts of the item that needs
+	 * redrawing.
+	 * 
+	 * @see Item.getDrawingArea
+	 * 
+	 * @param trait The visual trait that has changed.
+	 * 
+	 * @return The damaged area according to the visual trait that has changed.
+	 */
+	protected Rectangle[] getDamagedArea(ItemAppearence trait) {
+		
+		if (trait == ItemAppearence.LinkChanged) 
+			return new Rectangle[] {getLinkDrawArea()}; // Invalidate area where link is drawn
+			
+		return getDrawingArea();
+
 	}
 
@@ -2056,3 +2245,4 @@
 		_overlay = overlay;
 	}
+
 }
Index: /trunk/src/org/expeditee/items/ItemUtils.java
===================================================================
--- /trunk/src/org/expeditee/items/ItemUtils.java	(revision 120)
+++ /trunk/src/org/expeditee/items/ItemUtils.java	(revision 121)
@@ -2,4 +2,5 @@
 
 import java.awt.Color;
+import java.awt.Rectangle;
 import java.awt.image.ImageObserver;
 import java.io.File;
@@ -17,6 +18,8 @@
 import org.expeditee.gui.DisplayIO;
 import org.expeditee.gui.Frame;
+import org.expeditee.gui.FreeItems;
 import org.expeditee.gui.Vector;
 import org.expeditee.items.Item.HighlightMode;
+
 
 //Static methods that provide functions for the objects\
@@ -847,4 +850,47 @@
 	}
 
+	/**
+	 * Determines if an item is visible from a the current frame(s).
+	 * If the item is free then it is considered visible.
+	 * @param i The item to check
+	 * @return True if visible/free from given frame.
+	 */
+	public static boolean isVisible(Item i) {
+		if (DisplayIO.isTwinFramesOn()) {
+			if (!isVisible(DisplayIO.getFrames()[0], i)) {
+				return isVisible(DisplayIO.getFrames()[1], i);
+			} else {
+				return true;
+			}
+		} else  {
+			return isVisible(DisplayIO.getCurrentFrame(), i);
+		}
+	}
+
+	/**
+	 * Determines if an item is visible from a given frame.
+	 * If the item is free then it is considered visible.
+	 * 
+	 * @param fromFrame The frame to check from.
+	 * @param i The item to check
+	 * @return True if visible/free from given frame.
+	 */
+	public static boolean isVisible(Frame fromFrame, Item i) {
+		if (fromFrame == null) return false;
+		
+		Frame parent = i.getParent();
+		
+		if (parent == fromFrame) return true;
+		
+		else if (parent == null) return FreeItems.getInstance().contains(i);
+		
+		return fromFrame.getAllItems().contains(i) && i.isVisible();
+	}
+	
+	public static Rectangle expandRectangle(Rectangle r, int n) {
+		return new Rectangle(r.x - (n >> 1), r.y - (n >> 1), 
+				r.width + n, r.height + n);
+	}
+	
 	/*
 	 * FrameMouseActions while (!copies.isEmpty()) { Iterator<Item> iterator =
Index: /trunk/src/org/expeditee/items/Line.java
===================================================================
--- /trunk/src/org/expeditee/items/Line.java	(revision 120)
+++ /trunk/src/org/expeditee/items/Line.java	(revision 121)
@@ -54,4 +54,6 @@
 		return _lineStroke;
 	}
+	
+	
 
 	/**
@@ -344,6 +346,14 @@
 		if (_virtualSpot != null) {
 			_virtualSpot.paint(g);
+			invalidateVirtualSpot();
 			_virtualSpot = null;
 		}
+	}
+	
+	private void invalidateVirtualSpot() {
+		assert (_virtualSpot != null);
+		
+		invalidate(_virtualSpot.getDrawingArea());
+		
 	}
 
@@ -390,7 +400,5 @@
 			return;
 		if (arrowLength == AUTO_ARROWHEAD_LENGTH) {
-			arrowLength = length / ARROW_HEAD_TO_LENGTH_RATIO;
-			arrowLength = Math.max(MINIMUM_ARROW_HEAD_LENGTH, arrowLength);
-			arrowLength = Math.min(MAXIMUM_ARROW_HEAD_LENGTH, arrowLength);
+			arrowLength = getAutoArrowheadLength(length);
 			withArrow.setArrowhead(null);
 			if (arrowRatio < 0)
@@ -416,4 +424,18 @@
 		AffineTransform tx = AffineTransform.getRotateInstance(rad, x0, y0);
 		g.draw(tx.createTransformedShape((Shape) arrowhead));
+	}
+
+
+	/**
+	 * 
+	 * @param length The length of the line
+	 * @return
+	 */
+	private float getAutoArrowheadLength(float length) {
+		float arrowLength;
+		arrowLength = length / ARROW_HEAD_TO_LENGTH_RATIO;
+		arrowLength = Math.max(MINIMUM_ARROW_HEAD_LENGTH, arrowLength);
+		arrowLength = Math.min(MAXIMUM_ARROW_HEAD_LENGTH, arrowLength);
+		return arrowLength;
 	}
 
@@ -540,4 +562,11 @@
 	@Override
 	public void setThickness(float thick, boolean setConnectedThickness) {
+		
+		float oldThickness = this.getThickness();
+		if (thick == oldThickness) return;
+		boolean bigger = thick > oldThickness;
+		
+		if (!bigger) invalidateAll();
+		
 		if (thick < 0)
 			thick = DEFAULT_THICKNESS;
@@ -564,4 +593,6 @@
 			_lineStroke = new BasicStroke(Math.max(thick, MINIMUM_THICKNESS),
 					CAP, JOIN);
+		
+		if (bigger) invalidateAll();
 	}
 
@@ -759,4 +790,5 @@
 		spot.setPosition((int) x, (int) y);
 		_virtualSpot = spot;
+		invalidateVirtualSpot();
 	}
 
@@ -797,4 +829,5 @@
 		spot.setPosition((int) x, (int) y);
 		_virtualSpot = spot;
+		invalidateVirtualSpot();
 	}
 
@@ -974,4 +1007,5 @@
 			_poly.addPoint((int) one.getMaxX(), (int) one.getMaxY());
 		}
+	
 	}
 
@@ -1035,4 +1069,66 @@
 		return Point.distance(p1.x, p1.y, p2.x, p2.y);
 	}
+
+	@Override
+	public Rectangle[] getDrawingArea() { // TODO: CACHE - LIKE UPDATE POLYGON
+
+		float currentThickness = this.getThickness();
+		
+		// Establish bounds
+		int x = Math.min(_start.getX(), _end.getX());
+		int y = Math.min(_start.getY(), _end.getY());
+		int w = (Math.max(_start.getX(), _end.getX()) - x) + 1;
+		int h = (Math.max(_start.getY(), _end.getY()) - y) + 1;
+		
+		int thickness = (int)Math.ceil(currentThickness);
+		if (thickness < 4) thickness = 4;
+		int halfThickness = (int)Math.ceil(currentThickness / 2);
+		
+		// Consider line thickness
+		w += thickness;
+		h += thickness;
+		x -= halfThickness;
+		y -= halfThickness;
+	
+		Rectangle bounds = new Rectangle(x, y, w, h);
+		
+		// TODO: Cap bounds
+		
+		if (_end.hasVisibleArrow()) {
+			
+			double arrowLength = _end.getArrowheadLength();
+			
+			if (arrowLength == AUTO_ARROWHEAD_LENGTH) {
+				arrowLength = Math.ceil(getAutoArrowheadLength((float)getLength()));
+			} else {
+				arrowLength = Math.ceil(arrowLength);
+			}
+
+			arrowLength += ((thickness * 2) + 1);
+			int nArrowLength = (int)arrowLength;
+				
+			// NAIVE version - but probably more efficient in the long run... overall
+			// as opposed to advanced/expensive calculations for getting exact bounding box
+			Rectangle arrowBounds = new Rectangle(
+					_end.getX() - nArrowLength,
+					_end.getY() - nArrowLength,
+					2 * nArrowLength, 
+					2 * nArrowLength);
+			
+			if (currentThickness > 0.0f) {
+
+				arrowBounds = new Rectangle( 
+						arrowBounds.x - halfThickness,
+						arrowBounds.y - halfThickness,
+						arrowBounds.width + thickness,
+						arrowBounds.height + thickness);
+			}
+			
+			return new Rectangle[] { bounds, arrowBounds };
+		} else {
+			return new Rectangle[] { bounds };
+		}
+
+	}
 	
 	@Override
@@ -1046,3 +1142,4 @@
 		_end.setPermission(p);
 	}
+	
 }
Index: /trunk/src/org/expeditee/items/Picture.java
===================================================================
--- /trunk/src/org/expeditee/items/Picture.java	(revision 120)
+++ /trunk/src/org/expeditee/items/Picture.java	(revision 121)
@@ -526,3 +526,24 @@
 		super.translate(origin, ratio);
 	}
+
+	@Override
+	public Rectangle[] getDrawingArea() {
+		
+		Rectangle[] da = super.getDrawingArea();
+		
+		if (getLink() != null || getAction() != null) {
+			Rectangle[] da2 = new Rectangle[da.length + 1];
+			System.arraycopy(da, 0, da2, 0, da.length);
+			da2[da.length] = getLinkPoly().getBounds();
+			da2[da.length].translate(getX() - LEFT_MARGIN, getY() + getLinkYOffset());
+			da2[da.length].width += 2;
+			da2[da.length].height += 2;
+			da = da2;
+		} 
+		
+		return da;
+		
+	}
+	
+	
 }
